routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


// Authentication Routes...
Route::get('/', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('/login', 'Auth\LoginController@login')->name('login.user');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');

// Registration Routes...
Route::get('register', 'Auth\RegisterController@showRegistrationForm')->name('register');
Route::post('register', 'Auth\RegisterController@register');

// Password Reset Routes...
Route::get('password/reset', 'Auth\ForgotPasswordController@showLinkRequestForm')->name('password.request');
Route::post('password/email', 'Auth\ForgotPasswordController@sendResetLinkEmail')->name('password.email');
Route::get('password/reset/{token}', 'Auth\ResetPasswordController@showResetForm')->name('password.reset');
Route::post('password/reset', 'Auth\ResetPasswordController@reset');

Route::middleware('auth')->group(function() {

    Route::get('/home', 'HomeController@index')->name('home');

    // Edit user Routes...
    Route::post('edit', 'UserController@update')->name('update');
    Route::get('edit', 'UserController@edit')->name('edit');

    // User Routes...
    Route::get('profile', 'UserController@profile')->name('profile');

    // Delete user routes...
    Route::post('delete', 'UserController@delete')->name('delete');
    Route::get('delete', 'UserController@remove')->name('remove');

    Route::resource('faq', 'Faq\FaqController');
    Route::patch('faq{id}', 'Faq\FaqController@hidden');
    Route::get('hidden', 'Faq\FaqController@hiddenIndex')->name('hidden');
});

Route::group(['prefix' => 'admin', 'middleware' => ['auth' => 'admin'], 'namespace' => 'Admin'], function(){
    Route::resource('users', 'UsersController');

    Route::get('faq_respond{faq_id}', 'Faq\RespondFaqController@create')->name('faq_respond.create');
    Route::post('faq_respond', 'Faq\RespondFaqController@store')->name('faq_respond.store');
    Route::delete('faq_respond{id}', 'Faq\RespondFaqController@destroy')->name('faq_respond.destroy');
    Route::post('faq_respond/edit{faq_respond}', 'Faq\RespondFaqController@update')->name('faq_respond.update');
    Route::get('faq_respond/edit{faq_respond}', 'Faq\RespondFaqController@edit')->name('faq_respond.edit');
});

app/Faq.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class Faq extends Authenticatable
{

    use Notifiable;

    protected $table = "faq";

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'question', 'description'
    ];

    const post_rules = [
        'question' => ['required', 'string', 'max:255'],
        'description' => ['required', 'string', 'max:255'],
    ];

    const edit_rules = [
        'question' => ['required', 'string', 'max:255'],
        'description' => ['required', 'string', 'max:255'],
    ];

    public function user()
    {
        return $this->belongsTo('App\User');
    }
}

app/Http/Controllers/Admin/Faq/RespondFaqController.php
<?php

namespace App\Http\Controllers\Admin\Faq;

use App\Faq;
use App\Http\Controllers\Controller;
use App\RespondFaq;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Validator;

class RespondFaqController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Http\Response|\Illuminate\View\View
     */
    public function create()
    {
        $faq_id = request('faq_id');

        return view('faq_respond.create')->with('faq_id', $faq_id);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(Request $request)
    {
        $this->validation($request->all());
        $oRespondFaq = new RespondFaq($request->all());

        $oRespondFaq->faq_id = $request->faq_id;
        $oRespondFaq->user_id = Auth::id();
        $oRespondFaq->date = date('Y-m-d');

        if($oRespondFaq->save()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Uw antwoord is ingevoerd']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Http\Response|\Illuminate\View\View
     */
    public function edit($id)
    {
        $oRespondFaq = RespondFaq::find($id);

        return view('faq_respond.edit')->with('oRespondFaq', $oRespondFaq);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, $id)
    {
        $this->validation($request->all());
        $oUser = RespondFaq::find($id);

        $oUser->fill($request->all());

        $oUser->save();

        if($oUser->save()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Gegevens zijn gewijzigd']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function destroy($id)
    {
        $oRespondFaq = RespondFaq::find($id);
        $oRespondFaq->delete();

        if($oRespondFaq->delete()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Antwoord is verwijderd']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Get a validator for an incoming registration request.
     *
     * @param array $data
     * @return \Illuminate\Contracts\Validation\Validator
     */
    protected function Validation(array $data)
    {
        return Validator::make($data, RespondFaq::post_rules);

    }
}

app/Http/Controllers/Faq/FaqController.php
<?php

namespace App\Http\Controllers\Faq;

use App\Http\Controllers\Controller;
use App\RespondFaq;
use App\User;
use Illuminate\Http\Request;
use App\Faq;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\Validator;
use \Illuminate\Http\Response;

class FaqController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('faq.index')->with('aQuestion', Faq::where('visible', '0')->get());
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function hiddenIndex()
    {
        return view('faq.hidden')->with('aQuestion', Faq::where('visible', '1')->get());
    }

    /**
     * Show the form for creating a new resource.
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view('faq.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(Request $request)
    {
        $this->validation($request->all());
        $oFaq = new Faq($request->all());

        $oFaq->user_id = Auth::id();
        $oFaq->date = date('Y-m-d');
        $oFaq->visible = '0';

        if($oFaq->save()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Uw vraag is ingediend']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $oFaq = Faq::find($id);
        $aAnswer = RespondFaq::where('faq_id', $id)->get();

        return view('faq.show')->with(['oFaq' => $oFaq, 'aAnswer' => $aAnswer]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $oFaq = Faq::find($id);

        return view('faq.edit')->with('oFaq', $oFaq);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, $id)
    {
        $this->validation($request->all());
        $oFaq = Faq::find($id);

        $oFaq->fill($request->all());

        $oFaq->save();

        if($oFaq->save()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Vraag is gewijzigd']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function hidden($id)
    {
        $oFaq = Faq::find($id);
        $oFaq->visible = !$oFaq->visible;

        $oFaq->save();

        if($oFaq->save()){
            return Redirect::route('faq.index')->with(['alert' => ['class' => 'success', 'message' => 'Vraag is verplaatst']]);
        }else{
            return Redirect::route('faq.index')->with(['class' => 'danger', 'message' => 'Er is iets niet goed gegaan']);
        }
    }

    /**
     * Get a validator for an incoming registration request.
     *
     * @param array $data
     * @return \Illuminate\Contracts\Validation\Validator
     */
    protected function Validation(array $data)
    {
        return Validator::make($data, Faq::post_rules);

    }
}

resources/views/faq/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Create FAQ') }}</div>

                    <div class="card-body">
                        <form method="POST" action="{{ route('faq.store') }}">
                            @csrf

                            <div class="form-group row">
                                <label for="question" class="col-md-4 col-form-label text-md-right">{{ __('Question') }}</label>

                                <div class="col-md-6">
                                    <input id="question" type="text" class="form-control @error('question') is-invalid @enderror" name="question" value="{{ old('question') }}">

                                    @error('question')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group row">
                                <label for="description" class="col-md-4 col-form-label text-md-right">{{ __('Description') }}</label>

                                <div class="col-md-6">

                                    <textarea id="description" rows="4" cols="50" class="form-control @error('description') is-invalid @enderror" name="description" value="{{ old('description') }}"></textarea>
                                    @error('description')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Create FAQ') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/faq/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Create FAQ') }}</div>

                    <div class="card-body">
                        <form method="POST" action="{{ route('faq.update', $oFaq->id) }}">
                            @method('PATCH')
                            @csrf

                            <div class="form-group row">
                                <label for="question" class="col-md-4 col-form-label text-md-right">{{ __('Question') }}</label>

                                <div class="col-md-6">
                                    <input id="question" type="text" class="form-control @error('question') is-invalid @enderror" name="question" value="{{ $oFaq->question }}">

                                    @error('question')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group row">
                                <label for="description" class="col-md-4 col-form-label text-md-right">{{ __('Description') }}</label>

                                <div class="col-md-6">

                                    <textarea id="description" rows="4" cols="50" class="form-control @error('description') is-invalid @enderror" name="description">{{ $oFaq->description }}</textarea>
                                    @error('description')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class="form-group row mb-0">
                                <div class="col-md-6 offset-md-4">
                                    <button type="submit" class="btn btn-primary">
                                        {{ __('Create FAQ') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/faq/hidden.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        {{ __('FAQ') }}
                        <a class="btn btn-primary float-right text-white"  href="{{ route('faq.index')}}">Terug naar de FAQ</a>
                    </div>

                    <div class="card-body">

                        @csrf
                        <table class="table table-hover">
                            <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">{{ __('Question') }}</th>
                                <th scope="col">{{ __('Date') }}</th>
                                <th scope="col">{{ __('Actions') }}</th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach ($aQuestion as $oQuestion)
                                <tr class='clickable-row' data-href="{{ route('faq.show', $oQuestion->id)}}">
                                    <td>{{ $oQuestion->id }}</td>
                                    <td>{{ $oQuestion->question }}</td>
                                    <td>{{ $oQuestion->date }}</td>
                                    <td>
                                        {{ Form::open([ 'method' => 'patch', 'action' => [ 'Faq\FaqController@hidden', $oQuestion->id] ])}}
                                        {{ Form::button('<i class="fas fa-eye"></i>',['type' => 'submit', 'class' => 'btn btn-primary replace']) }}
                                        {{ Form::close() }}
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/faq/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        {{ __('FAQ') }}
                        @if(Auth::user()->isRole()== 'admin')
                            <a class="btn btn-danger float-right text-white" href="{{ route('hidden')}}">Verplaatste vragen</a>
                        @endif
                        <a class="btn btn-primary float-right text-white mr-3"  href="{{ route('faq.create')}}">Voeg een vraag toe</a>
                    </div>

                    <div class="card-body">

                        @csrf
                        <table class="table table-hover">
                            <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">{{ __('Question') }}</th>
                                <th scope="col">{{ __('Date') }}</th>
                                <th scope="col">{{ __('Geplaatst door') }}</th>
                                @if(Auth::user()->isRole()== 'admin')
                                    <th scope="col" width="20"></th>
                                    <th scope="col" width="20"></th>
                                @endif
                            </tr>
                            </thead>
                            <tbody>
                            @foreach ($aQuestion as $oQuestion)
                                <tr class='clickable-row' data-href="{{ route('faq.show', $oQuestion->id)}}">
                                    <td>{{ $oQuestion->id }}</td>
                                    <td>{{ $oQuestion->question }}</td>
                                    <td>{{ $oQuestion->date }}</td>
                                    <td>{{ $oQuestion->user->email }}</td>
                                    @if(Auth::user()->isRole()== 'admin')
                                        <td>
                                            <a class="btn btn-primary text-white" href="{{ route('faq.edit', ['faq' => $oQuestion]) }}"><i class="far fa-edit"></i></a>
                                        </td>
                                        <td>
                                            {{ Form::open([ 'method' => 'patch', 'action' => [ 'Faq\FaqController@hidden', $oQuestion->id] ])}}
                                            {{ Form::button('<i class="fa fa-eye-slash"></i>',['type' => 'submit', 'class' => 'btn btn-danger replace']) }}
                                            {{ Form::close() }}
                                        </td>
                                    @endif
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/faq/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Question') }}</div>
                    <div class="card-body">
                            <div class="form-group ">
                                <h2><b>{{ $oFaq->question }}?</b></h2>
                            </div>
                            <div class="form-group ">
                                <label>{{ $oFaq->description }}</label>
                            </div>
                    </div>
                </div>
                @if(Auth::user()->isRole() == 'admin')
                <a class="btn btn-primary text-white mt-4" href="{{ route('faq_respond.create', ['faq_id' => $oFaq->id]) }}">Voeg een antwoord toe</a>
                @endif
                @if(!$aAnswer->isEmpty())
                <div class="card mt-2">
                    <div class="card-header">{{ __('Answer') }}</div>
                    <div class="card-body">
                        @foreach($aAnswer as $answers)
                            <div class="clearfix mt-3">
                                <div class="float-left mt-2">{{ $answers->answer }}</div>
                                @if(Auth::user()->isRole() == 'admin')
                                <div class="float-right">
                                    {{ Form::open([ 'method' => 'delete', 'route' => [ 'faq_respond.destroy', $answers->id] ])}}
                                    {{ Form::button('<i class="fa fa-trash-alt"></i>',['type' => 'submit', 'class' => 'btn btn-danger']) }}
                                    {{ Form::close() }}
                                </div>
                                <div class="float-right">
                                    <a class="btn btn-primary text-white" href="{{ route('faq_respond.edit', ['faq_respond' => $answers]) }}"><i class="far fa-edit"></i></a>
                                </div>
                                @endif
                                <div class="float-right mr-3 mt-2"><b>{{ $answers->date }} door: {{ $answers->user->firstname }} {{ $answers->user->lastname }}</b></div>
                            </div>
                        @endforeach
                    </div>
                </div>
                @endif
            </div>
        </div>
    </div>
@endsection